diff --git a/testing/xpcshell/remotexpcshelltests.py b/testing/xpcshell/remotexpcshelltests.py
index c5124880f8..91f7dd1d6a 100644
--- a/testing/xpcshell/remotexpcshelltests.py
+++ b/testing/xpcshell/remotexpcshelltests.py
@@ -4,6 +4,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import posixpath
 import sys, os
 import subprocess
@@ -169,7 +170,7 @@ class RemoteXPCShellTestThread(xpcshell.XPCShellTestThread):
             # The minidumps directory is automatically created when Fennec
             # (first) starts, so its lack of presence is a hint that
             # something went wrong.
-            print "Automation Error: No crash directory (%s) found on remote device" % self.remoteMinidumpDir
+            print("Automation Error: No crash directory (%s) found on remote device" % self.remoteMinidumpDir)
             # Whilst no crash was found, the run should still display as a failure
             return True
         with mozfile.TemporaryDirectory() as dumpDir:
@@ -276,7 +277,7 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
         elif os.path.isdir(os.path.join(here, 'tests')):
             self.xpcDir = os.path.join(here, 'tests')
         else:
-            print >> sys.stderr, "Couldn't find local xpcshell test directory"
+            print("Couldn't find local xpcshell test directory", file=sys.stderr)
             sys.exit(1)
 
         if options.localAPK:
@@ -321,7 +322,7 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
         localWrapper = tempfile.mktemp()
         f = open(localWrapper, "w")
         f.write("#!/system/bin/sh\n")
-        for envkey, envval in self.env.iteritems():
+        for envkey, envval in self.env.items():
             f.write("export %s=%s\n" % (envkey, envval))
         f.writelines([
             "cd $1\n",
@@ -376,7 +377,7 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
                 if packageName:
                     self.appRoot = self.device.getAppRoot(packageName.strip())
             except Exception as detail:
-                print "unable to determine app root: " + str(detail)
+                print("unable to determine app root: " + str(detail))
                 pass
         return None
 
@@ -418,11 +419,11 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
         for fname in binaries:
             local = os.path.join(self.localBin, fname)
             if os.path.isfile(local):
-                print >> sys.stderr, "Pushing %s.." % fname
+                print("Pushing %s.." % fname, file=sys.stderr)
                 remoteFile = remoteJoin(self.remoteBinDir, fname)
                 self.device.pushFile(local, remoteFile)
             else:
-                print >> sys.stderr, "*** Expected binary %s not found in %s!" % (fname, self.localBin)
+                print("*** Expected binary %s not found in %s!" % (fname, self.localBin), file=sys.stderr)
 
         local = os.path.join(self.localBin, "components/httpd.js")
         remoteFile = remoteJoin(self.remoteComponentsDir, "httpd.js")
@@ -449,7 +450,7 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
                 dir = tempfile.mkdtemp()
                 for info in self.localAPKContents.infolist():
                     if info.filename.endswith(".so"):
-                        print >> sys.stderr, "Pushing %s.." % info.filename
+                        print("Pushing %s.." % info.filename, file=sys.stderr)
                         remoteFile = remoteJoin(self.remoteBinDir, os.path.basename(info.filename))
                         self.localAPKContents.extract(info, dir)
                         localFile = os.path.join(dir, info.filename)
@@ -468,9 +469,9 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
 
         for file in os.listdir(self.localLib):
             if (file.endswith(".so")):
-                print >> sys.stderr, "Pushing %s.." % file
+                print("Pushing %s.." % file, file=sys.stderr)
                 if 'libxul' in file:
-                    print >> sys.stderr, "This is a big file, it could take a while."
+                    print("This is a big file, it could take a while.", file=sys.stderr)
                 localFile = os.path.join(self.localLib, file)
                 remoteFile = remoteJoin(self.remoteBinDir, file)
                 self.device.pushFile(localFile, remoteFile)
@@ -482,7 +483,7 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
             for root, dirs, files in os.walk(localArmLib):
                 for file in files:
                     if (file.endswith(".so")):
-                        print >> sys.stderr, "Pushing %s.." % file
+                        print("Pushing %s.." % file, file=sys.stderr)
                         localFile = os.path.join(root, file)
                         remoteFile = remoteJoin(self.remoteBinDir, file)
                         self.device.pushFile(localFile, remoteFile)
@@ -495,7 +496,7 @@ class XPCShellRemote(xpcshell.XPCShellTests, object):
             self.device.pushDir(self.testingModulesDir, self.remoteModulesDir)
 
     def setupTestDir(self):
-        print 'pushing %s' % self.xpcDir
+        print('pushing %s' % self.xpcDir)
         try:
             # The tests directory can be quite large: 5000 files and growing!
             # Sometimes - like on a low-end aws instance running an emulator - the push
@@ -560,7 +561,7 @@ class PathMapping:
 
 def main():
     if sys.version_info < (2,7):
-        print >>sys.stderr, "Error: You must use python version 2.7 or newer but less than 3.0"
+        print("Error: You must use python version 2.7 or newer but less than 3.0", file=sys.stderr)
         sys.exit(1)
 
     parser = parser_remote()
@@ -570,10 +571,10 @@ def main():
             if (file.endswith(".apk") and file.startswith("fennec")):
                 options.localAPK = os.path.join(options.objdir, "dist")
                 options.localAPK = os.path.join(options.localAPK, file)
-                print >>sys.stderr, "using APK: " + options.localAPK
+                print("using APK: " + options.localAPK, file=sys.stderr)
                 break
         else:
-            print >>sys.stderr, "Error: please specify an APK"
+            print("Error: please specify an APK", file=sys.stderr)
             sys.exit(1)
 
     options = verifyRemoteOptions(parser, options)
@@ -588,12 +589,12 @@ def main():
             dm = mozdevice.DroidADB(packageName=None, deviceRoot=options.remoteTestRoot)
     else:
         if not options.deviceIP:
-            print "Error: you must provide a device IP to connect to via the --device option"
+            print("Error: you must provide a device IP to connect to via the --device option")
             sys.exit(1)
         dm = mozdevice.DroidSUT(options.deviceIP, options.devicePort, deviceRoot=options.remoteTestRoot)
 
     if options.interactive and not options.testPath:
-        print >>sys.stderr, "Error: You must specify a test filename in interactive mode!"
+        print("Error: You must specify a test filename in interactive mode!", file=sys.stderr)
         sys.exit(1)
 
     if options.xpcshell is None:
diff --git a/testing/xpcshell/runxpcshelltests.py b/testing/xpcshell/runxpcshelltests.py
index 34af6639fb..97eec4f836 100755
--- a/testing/xpcshell/runxpcshelltests.py
+++ b/testing/xpcshell/runxpcshelltests.py
@@ -4,6 +4,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import copy
 import importlib
 import json
@@ -24,7 +25,31 @@ import traceback
 
 from collections import deque, namedtuple
 from distutils import dir_util
-from distutils.version import LooseVersion
+try:
+    from distutils.version import LooseVersion
+except ImportError:
+    import re as _re
+    class LooseVersion:
+        def __init__(self, vstring):
+            self.vstring = vstring
+            self.version = [int(x) if x.isdigit() else x for x in _re.split(r'[.\-]', vstring)]
+        def __str__(self): return self.vstring
+        def __repr__(self): return "LooseVersion ('%s')" % str(self)
+        def _cmp(self, other):
+            if not isinstance(other, LooseVersion): other = LooseVersion(other)
+            a, b = self.version, other.version
+            for i in range(max(len(a), len(b))):
+                va = a[i] if i < len(a) else 0
+                vb = b[i] if i < len(b) else 0
+                if type(va) != type(vb): va, vb = str(va), str(vb)
+                if va < vb: return -1
+                if va > vb: return 1
+            return 0
+        def __eq__(self, other): return self._cmp(other) == 0
+        def __lt__(self, other): return self._cmp(other) < 0
+        def __le__(self, other): return self._cmp(other) <= 0
+        def __gt__(self, other): return self._cmp(other) > 0
+        def __ge__(self, other): return self._cmp(other) >= 0
 from multiprocessing import cpu_count
 from argparse import ArgumentParser
 from subprocess import Popen, PIPE, STDOUT
@@ -91,9 +116,9 @@ def cleanup_encoding(s):
        points, etc.  If it is a byte string, it is assumed to be
        UTF-8, but it may not be *correct* UTF-8.  Return a
        sanitized unicode object."""
-    if not isinstance(s, basestring):
-        return unicode(s)
-    if not isinstance(s, unicode):
+    if not isinstance(s, str):
+        return str(s)
+    if not isinstance(s, str):
         s = s.decode('utf-8', 'replace')
     # Replace all C0 and C1 control characters with \xNN escapes.
     return _cleanup_encoding_re.sub(_cleanup_encoding_repl, s)
@@ -267,8 +292,8 @@ class XPCShellTestThread(Thread):
         self.log.info("%s | current directory: %r" % (name, testdir))
         # Show only those environment variables that are changed from
         # the ambient environment.
-        changedEnv = (set("%s=%s" % i for i in self.env.iteritems())
-                      - set("%s=%s" % i for i in os.environ.iteritems()))
+        changedEnv = (set("%s=%s" % i for i in self.env.items())
+                      - set("%s=%s" % i for i in os.environ.items()))
         self.log.info("%s | environment: %s" % (name, list(changedEnv)))
 
     def killTimeout(self, proc):
@@ -514,7 +539,7 @@ class XPCShellTestThread(Thread):
     def log_line(self, line):
         """Log a line of output (either a parser json object or text output from
         the test process"""
-        if isinstance(line, basestring):
+        if isinstance(line, str):
             line = self.fix_text_output(line).rstrip('\r\n')
             self.log.process_output(self.proc_ident,
                                     line,
@@ -822,8 +847,8 @@ class XPCShellTests(object):
         if os.path.exists(ini_path):
             return TestManifest([ini_path], strict=True)
         else:
-            print >> sys.stderr, ("Failed to find manifest at %s; use --manifest "
-                                  "to set path explicitly." % (ini_path,))
+            print(("Failed to find manifest at %s; use --manifest "
+                                  "to set path explicitly." % (ini_path,)), file=sys.stderr)
             sys.exit(1)
 
     def buildTestList(self, test_tags=None, test_paths=None):
@@ -1002,7 +1027,7 @@ class XPCShellTests(object):
                 # node did not support ALPN until this version.
                 if version >= LooseVersion("5.0.0"):
                     nodeBin = localPath
-            except (subprocess.CalledProcessError, OSError), e:
+            except (subprocess.CalledProcessError, OSError) as e:
                 self.log.error('Could not retrieve node version: %s' % str(e))
 
         if os.getenv('MOZ_ASSUME_NODE_RUNNING', None):
@@ -1030,7 +1055,7 @@ class XPCShellTests(object):
                             searchObj = re.search( r'HTTP2 server listening on port (.*)', msg, 0)
                             if searchObj:
                               self.env["MOZHTTP2_PORT"] = searchObj.group(1)
-                    except OSError, e:
+                    except OSError as e:
                         # This occurs if the subprocess couldn't be started
                         self.log.error('Could not run %s server: %s' % (name, str(e)))
 
@@ -1043,7 +1068,7 @@ class XPCShellTests(object):
         """
           Shut down our node process, if it exists
         """
-        for name, proc in self.nodeProc.iteritems():
+        for name, proc in self.nodeProc.items():
             self.log.info('Node %s server shutting down ...' % name)
             if proc.poll() is not None:
                 self.log.info('Node server %s already dead %s' % (name, proc.poll()))
@@ -1150,7 +1175,7 @@ class XPCShellTests(object):
                 os.remove(failure_manifest)
                 manifest = rerun_manifest
             else:
-                print >> sys.stderr, "No failures were found to re-run."
+                print("No failures were found to re-run.", file=sys.stderr)
                 sys.exit(1)
 
         if testingModulesDir:
@@ -1220,7 +1245,7 @@ class XPCShellTests(object):
         # All of the keys in question should be ASCII.
         fixedInfo = {}
         for k, v in self.mozInfo.items():
-            if isinstance(k, unicode):
+            if isinstance(k, str):
                 k = k.encode('ascii')
             fixedInfo[k] = v
         self.mozInfo = fixedInfo
@@ -1483,12 +1508,12 @@ def main():
     log = commandline.setup_logging("XPCShell", options, {"tbpl": sys.stdout})
 
     if options.xpcshell is None:
-        print >> sys.stderr, """Must provide path to xpcshell using --xpcshell"""
+        print("""Must provide path to xpcshell using --xpcshell""", file=sys.stderr)
 
     xpcsh = XPCShellTests(log)
 
     if options.interactive and not options.testPath:
-        print >>sys.stderr, "Error: You must specify a test filename in interactive mode!"
+        print("Error: You must specify a test filename in interactive mode!", file=sys.stderr)
         sys.exit(1)
 
     if not xpcsh.runTests(**vars(options)):
diff --git a/testing/xpcshell/selftest.py b/testing/xpcshell/selftest.py
index 071ab5eda6..711302188b 100755
--- a/testing/xpcshell/selftest.py
+++ b/testing/xpcshell/selftest.py
@@ -447,7 +447,7 @@ class XPCShellTestsTests(unittest.TestCase):
         """
         testlines = []
         for t in tests:
-            testlines.append("[%s]" % (t if isinstance(t, basestring)
+            testlines.append("[%s]" % (t if isinstance(t, str)
                                        else t[0]))
             if isinstance(t, tuple):
                 testlines.extend(t[1:])
@@ -1041,7 +1041,7 @@ add_test({
         try:
             # The actual return value is never checked because we raise.
             self.assertTestResult(True)
-        except Exception, ex:
+        except Exception as ex:
             raised = True
             self.assertEquals(ex.message[0:9], "head file")
 
@@ -1058,7 +1058,7 @@ add_test({
 
         try:
             self.assertTestResult(True)
-        except Exception, ex:
+        except Exception as ex:
             raised = True
             self.assertEquals(ex.message[0:9], "tail file")
 
diff --git a/testing/xpcshell/xpcshellcommandline.py b/testing/xpcshell/xpcshellcommandline.py
index d2a8e6bc13..b106fa058f 100644
--- a/testing/xpcshell/xpcshellcommandline.py
+++ b/testing/xpcshell/xpcshellcommandline.py
@@ -5,7 +5,7 @@ from mozlog import commandline
 
 def add_common_arguments(parser):
     parser.add_argument("--app-path",
-                        type=unicode, dest="appPath", default=None,
+                        type=str, dest="appPath", default=None,
                         help="application directory (as opposed to XRE directory)")
     parser.add_argument("--interactive",
                         action="store_true", dest="interactive", default=False,
@@ -22,7 +22,7 @@ def add_common_arguments(parser):
     parser.add_argument("--dump-tests", type=str, dest="dump_tests", default=None,
                         help="Specify path to a filename to dump all the tests that will be run")
     parser.add_argument("--manifest",
-                        type=unicode, dest="manifest", default=None,
+                        type=str, dest="manifest", default=None,
                         help="Manifest of test directories to use")
     parser.add_argument("--no-logfiles",
                         action="store_false", dest="logfiles",
diff --git a/toolkit/library/dependentlibs.py b/toolkit/library/dependentlibs.py
index 958fe5ef1d..dabd18a50c 100644
--- a/toolkit/library/dependentlibs.py
+++ b/toolkit/library/dependentlibs.py
@@ -29,7 +29,7 @@ def dependentlibs_dumpbin(lib):
     deps = []
     for line in proc.stdout:
         # Each line containing an imported library name starts with 4 spaces
-        match = re.match('    (\S+)', line)
+        match = re.match(r'    (\S+)', line)
         if match:
              deps.append(match.group(1))
         elif len(deps):
@@ -44,7 +44,7 @@ def dependentlibs_mingw_objdump(lib):
     proc = subprocess.Popen(['objdump', '-x', lib], stdout = subprocess.PIPE)
     deps = []
     for line in proc.stdout:
-        match = re.match('\tDLL Name: (\S+)', line)
+        match = re.match('\tDLL Name: (\\S+)', line)
         if match:
             deps.append(match.group(1))
     proc.wait()
@@ -77,13 +77,15 @@ def dependentlibs_readelf(lib):
         # or with BSD readelf:
         #  tag TYPE            value
         # Looking for NEEDED type entries
+        if isinstance(line, bytes):
+            line = line.decode('utf-8', errors='replace')
         tmp = line.split(' ', 3)
         if len(tmp) > 3 and 'NEEDED' in tmp[2]:
             # NEEDED lines look like:
             # 0x00000001 (NEEDED)             Shared library: [libname]
             # or with BSD readelf:
             # 0x00000001 NEEDED               Shared library: [libname]
-            match = re.search('\[(.*)\]', tmp[3])
+            match = re.search(r'\[(.*)\]', tmp[3])
             if match:
                 deps.append(match.group(1))
     proc.wait()
@@ -149,7 +151,7 @@ def gen_list(output, lib):
 
     deps = dependentlibs(lib, libpaths, func)
     deps[lib] = mozpath.join(libpaths[0], lib)
-    output.write('\n'.join(deps.keys()) + '\n')
+    output.write('\n'.join(list(deps.keys())) + '\n')
     return set(deps.values())
 
 def main():
diff --git a/toolkit/mozapps/installer/find-dupes.py b/toolkit/mozapps/installer/find-dupes.py
index 34ef675f49..5fc3a11536 100644
--- a/toolkit/mozapps/installer/find-dupes.py
+++ b/toolkit/mozapps/installer/find-dupes.py
@@ -23,23 +23,23 @@ def find_dupes(source):
         md5s[m][1].append(p)
     total = 0
     num_dupes = 0
-    for m, (size, paths) in md5s.iteritems():
+    for m, (size, paths) in md5s.items():
         if len(paths) > 1:
-            print 'Duplicates %d bytes%s:' % (size,
-                  ' (%d times)' % (len(paths) - 1) if len(paths) > 2 else '')
-            print ''.join('  %s\n' % p for p in paths)
+            print('Duplicates %d bytes%s:' % (size,
+                  ' (%d times)' % (len(paths) - 1) if len(paths) > 2 else ''))
+            print(''.join('  %s\n' % p for p in paths))
             total += (len(paths) - 1) * size
             num_dupes += 1
     if num_dupes:
-        print "WARNING: Found %d duplicated files taking %d bytes" % \
-              (num_dupes, total) + " (uncompressed)"
+        print("WARNING: Found %d duplicated files taking %d bytes" % \
+              (num_dupes, total) + " (uncompressed)")
 
 
 def main():
     if len(sys.argv) != 2:
         import os
-        print >>sys.stderr, "Usage: %s directory" % \
-                            os.path.basename(sys.argv[0])
+        print("Usage: %s directory" % \
+                            os.path.basename(sys.argv[0]), file=sys.stderr)
         sys.exit(1)
 
     find_dupes(sys.argv[1])
diff --git a/toolkit/mozapps/installer/informulate.py b/toolkit/mozapps/installer/informulate.py
index 6af43ac685..eeb7989021 100644
--- a/toolkit/mozapps/installer/informulate.py
+++ b/toolkit/mozapps/installer/informulate.py
@@ -15,7 +15,7 @@ def parse_cmdline(args):
     for arg in args:
         key, s, value = arg.partition("=")
         if s == '':
-            print "ERROR: Malformed command line key value pairing (%s)" % arg
+            print("ERROR: Malformed command line key value pairing (%s)" % arg)
             exit(1)
         contents[key.lower()] = value
     return contents
@@ -23,7 +23,7 @@ def parse_cmdline(args):
 
 def main():
     if len(sys.argv) < 2:
-        print "ERROR: You must specify an output file"
+        print("ERROR: You must specify an output file")
         exit(1)
 
     all_key_value_pairs = {}
@@ -34,7 +34,7 @@ def main():
         'MOZ_APP_VERSION', 'MOZ_APP_MAXVERSION', 'MOZ_APP_ID',
         'CC', 'CXX', 'LD', 'AS']
 
-    all_key_value_pairs = dict([(x.lower(), buildconfig.substs[x]) for x in important_substitutions])
+    all_key_value_pairs = {x.lower(): buildconfig.substs[x] for x in important_substitutions}
     all_key_value_pairs.update(parse_cmdline(sys.argv[2:]))
 
     with open(sys.argv[1], "w+") as f:
diff --git a/toolkit/mozapps/installer/l10n-repack.py b/toolkit/mozapps/installer/l10n-repack.py
index fcf3e773cd..5d214d807f 100644
--- a/toolkit/mozapps/installer/l10n-repack.py
+++ b/toolkit/mozapps/installer/l10n-repack.py
@@ -13,7 +13,7 @@ import buildconfig
 
 # Set of files or directories not listed in a chrome.manifest but that are
 # localized.
-NON_CHROME = set([
+NON_CHROME = {
     '**/crashreporter*.ini',
     'searchplugins',
     'dictionaries',
@@ -24,7 +24,7 @@ NON_CHROME = set([
     'extensions/langpack-*@*',
     'distribution/extensions/langpack-*@*',
     'chrome/**/searchplugins/*.xml',
-])
+}
 
 
 def valid_extra_l10n(arg):
diff --git a/toolkit/mozapps/installer/packager.py b/toolkit/mozapps/installer/packager.py
index 42a66812f9..d75ce8ea6e 100644
--- a/toolkit/mozapps/installer/packager.py
+++ b/toolkit/mozapps/installer/packager.py
@@ -29,11 +29,11 @@ import mozpack.path as mozpath
 import buildconfig
 from argparse import ArgumentParser
 import os
-from StringIO import StringIO
+from io import StringIO
 import subprocess
 import platform
 
-class ToolLauncher(object):
+class ToolLauncher:
     '''
     Helper to execute tools like xpcshell with the appropriate environment.
         launcher = ToolLauncher()
@@ -75,16 +75,16 @@ class ToolLauncher(object):
 
                 vcdir = os.path.abspath(os.path.join(env[e], '../../VC/bin'))
                 if os.path.exists(vcdir):
-                    env['PATH'] = '%s;%s' % (vcdir, env['PATH'])
+                    env['PATH'] = '{};{}'.format(vcdir, env['PATH'])
                     break
 
         # Work around a bug in Python 2.7.2 and lower where unicode types in
         # environment variables aren't handled by subprocess.
         for k, v in env.items():
-            if isinstance(v, unicode):
+            if isinstance(v, str):
                 env[k] = v.encode('utf-8')
 
-        print >>errors.out, 'Executing', ' '.join(cmd)
+        print('Executing', ' '.join(cmd), file=errors.out)
         errors.out.flush()
         return subprocess.call(cmd, env=env)
 
@@ -138,10 +138,11 @@ def precompile_cache(registry, source_path, gre_path, app_path):
         jar = JarReader(cache)
         resource = '/resource/%s/' % resource
         for f in jar:
-            if resource in f.filename:
-                path = f.filename[f.filename.index(resource) + len(resource):]
+            filename = f.filename.decode('utf-8') if isinstance(f.filename, bytes) else f.filename
+            if resource in filename:
+                path = filename[filename.index(resource) + len(resource):]
                 if registry.contains(path):
-                    registry.add(f.filename, GeneratedFile(f.read()))
+                    registry.add(filename, GeneratedFile(f.read()))
         jar.close()
     finally:
         if os.path.exists(cache):
@@ -180,7 +181,7 @@ def split_define(define):
     return (define, 1)
 
 
-class NoPkgFilesRemover(object):
+class NoPkgFilesRemover:
     '''
     Formatter wrapper to handle NO_PKG_FILES.
     '''
diff --git a/toolkit/mozapps/installer/unpack.py b/toolkit/mozapps/installer/unpack.py
index 01a0144229..99e3fedfd3 100644
--- a/toolkit/mozapps/installer/unpack.py
+++ b/toolkit/mozapps/installer/unpack.py
@@ -10,8 +10,8 @@ import buildconfig
 
 def main():
     if len(sys.argv) != 2:
-        print >>sys.stderr, "Usage: %s directory" % \
-                            os.path.basename(sys.argv[0])
+        print("Usage: %s directory" % \
+                            os.path.basename(sys.argv[0]), file=sys.stderr)
         sys.exit(1)
 
     buildconfig.substs['USE_ELF_HACK'] = False
diff --git a/toolkit/mozapps/installer/windows/nsis/preprocess-locale.py b/toolkit/mozapps/installer/windows/nsis/preprocess-locale.py
index cb7303a129..8690d784dc 100644
--- a/toolkit/mozapps/installer/windows/nsis/preprocess-locale.py
+++ b/toolkit/mozapps/installer/windows/nsis/preprocess-locale.py
@@ -37,7 +37,7 @@ def get_locale_strings(path, prefix, middle, add_cr):
              linefeeds when there isn't one already
     """
     output = ""
-    fp = open(path, "r")
+    fp = open(path)
     for line in fp:
         line = line.strip()
         if line == "" or line[0] == "#":
@@ -84,12 +84,12 @@ def preprocess_locale_files(config_dir, l10ndirs):
                                         "LangString ^",
                                         " 0 ",
                                         False)
-    fp.write(unicode(locale_strings, "utf-8").encode("utf-16-le"))
+    fp.write(str(locale_strings, "utf-8").encode("utf-16-le"))
     fp.close()
 
     # Create the Modern User Interface language file
     fp = open_utf16le_file(join(config_dir, "baseLocale.nsh"))
-    fp.write((u""";NSIS Modern User Interface - Language File
+    fp.write((""";NSIS Modern User Interface - Language File
 ;Compatible with Modern UI 1.68
 ;Language: baseLocale (0)
 !insertmacro MOZ_MUI_LANGUAGEFILE_BEGIN \"baseLocale\"
@@ -97,8 +97,8 @@ def preprocess_locale_files(config_dir, l10ndirs):
 """).encode("utf-16-le"))
     locale_strings = get_locale_strings(lookup("mui.properties", l10ndirs),
                                         "!define ", " ", True)
-    fp.write(unicode(locale_strings, "utf-8").encode("utf-16-le"))
-    fp.write(u"!insertmacro MOZ_MUI_LANGUAGEFILE_END\n".encode("utf-16-le"))
+    fp.write(str(locale_strings, "utf-8").encode("utf-16-le"))
+    fp.write("!insertmacro MOZ_MUI_LANGUAGEFILE_END\n".encode("utf-16-le"))
     fp.close()
 
     # Create the custom language file for our custom strings
@@ -108,7 +108,7 @@ def preprocess_locale_files(config_dir, l10ndirs):
                                         "LangString ",
                                         " 0 ",
                                         True)
-    fp.write(unicode(locale_strings, "utf-8").encode("utf-16-le"))
+    fp.write(str(locale_strings, "utf-8").encode("utf-16-le"))
     fp.close()
 
 def create_nlf_file(moz_dir, ab_cd, config_dir):
@@ -124,8 +124,7 @@ def create_nlf_file(moz_dir, ab_cd, config_dir):
 
     # Check whether the locale is right to left from locales.nsi.
     fp = open(join(moz_dir,
-                   "toolkit/mozapps/installer/windows/nsis/locales.nsi"),
-              "r")
+                   "toolkit/mozapps/installer/windows/nsis/locales.nsi"))
     for line in fp:
         line = line.strip()
         if line == "!define " + ab_cd + "_rtl":
@@ -138,7 +137,7 @@ def create_nlf_file(moz_dir, ab_cd, config_dir):
     # along with the default codepage, font name, and font size represented
     # by the '-' character.
     fp = open_utf16le_file(join(config_dir, "baseLocale.nlf"))
-    fp.write((u"""# Header, don't edit
+    fp.write(("""# Header, don't edit
 NLF v6
 # Start editing here
 # Language ID
@@ -175,7 +174,7 @@ def preprocess_locale_file(config_dir,
                                         "LangString ",
                                         " 0 ",
                                         True)
-    fp.write(unicode(locale_strings, "utf-8").encode("utf-16-le"))
+    fp.write(str(locale_strings, "utf-8").encode("utf-16-le"))
     fp.close()
 
 
@@ -187,9 +186,9 @@ def convert_utf8_utf16le(in_file_path, out_file_path):
     in_file_path  - the path to the UTF-8 source file to convert
     out_file_path - the path to the UTF-16LE destination file to create
     """
-    in_fp = open(in_file_path, "r")
+    in_fp = open(in_file_path)
     out_fp = open_utf16le_file(out_file_path)
-    out_fp.write(unicode(in_fp.read(), "utf-8").encode("utf-16-le"))
+    out_fp.write(str(in_fp.read(), "utf-8").encode("utf-16-le"))
     in_fp.close()
     out_fp.close()
 
diff --git a/toolkit/mozapps/update/updater/gen_cert_header.py b/toolkit/mozapps/update/updater/gen_cert_header.py
index 7ecb156197..2db776bb7d 100644
--- a/toolkit/mozapps/update/updater/gen_cert_header.py
+++ b/toolkit/mozapps/update/updater/gen_cert_header.py
@@ -1,5 +1,3 @@
-from __future__ import print_function
-
 import binascii
 
 def file_byte_generator(filename, block_size = 512):
@@ -7,8 +5,7 @@ def file_byte_generator(filename, block_size = 512):
     while True:
       block = f.read(block_size)
       if block:
-        for byte in block:
-          yield byte
+        yield from block
       else:
         break
 
diff --git a/tools/check-moz-style/checkmozstyle.py b/tools/check-moz-style/checkmozstyle.py
index d8261aec5a..6e45192432 100755
--- a/tools/check-moz-style/checkmozstyle.py
+++ b/tools/check-moz-style/checkmozstyle.py
@@ -116,7 +116,7 @@ def process_patch(patch_string, root, cwd, scm):
         cpplint.error("patch", 0, "patch/nodescription", 3,
                       "Patch does not have a description.")
 
-    for filename, diff in patch.files.iteritems():
+    for filename, diff in patch.files.items():
         file_extension = os.path.splitext(filename)[1]
 
         if file_extension in ['.cpp', '.c', '.h']:
